Option Explicit

'Sub _()

Const ForReading = 1
Const ForWriting = 2

Dim objDialog, intResult
Dim BreakFile
Dim MyPath
Dim Dic1, Dic2
Dim objFSO, objFile
Dim strContents, arrlines
Dim X, temp1, temp2, temp, end_
Dim first1, first2
Dim i

'#   
Set objDialog = CreateObject("UserAccounts.CommonDialog")
objDialog.Filter = "Input Files|*.csv|All Files|*.*"
objDialog.FilterIndex = 1
objDialog.InitialDir = ""
intResult = objDialog.ShowOpen

    If intResult = 0 Then
        'Exit Sub
        WScript.Quit
    Else
        BreakFile = objDialog.Filename
    End If

    'MyPath = ThisWorkbook.Path & "\"
    MyPath = Left(WScript.ScriptFullName, (Len(WScript.ScriptFullName)) - (Len(WScript.ScriptName)))

    Set Dic1 = CreateObject("Scripting.Dictionary")
    Set Dic2 = CreateObject("Scripting.Dictionary")
    Dic1.CompareMode = vbTextCompare
    Dic2.CompareMode = vbTextCompare

    Set objFSO = CreateObject("Scripting.FileSystemObject")
    Set objFile = objFSO.OpenTextFile(MyPath & ".csv", ForReading)
    strContents = objFile.ReadAll: objFile.Close: Set objFile = Nothing
    arrlines = Split(strContents, vbCrLf)
    strContents = Empty
    
    For Each X In arrlines
        If InStr(X, ";") > 0 Then
            temp1 = Split(X, ";")(0)
            If first1 = Empty Then first1 = temp1
            temp2 = Split(X, ";")(1)
            If first2 = Empty Then first2 = temp2
            If Not Dic1.exists(CStr(temp1)) Then Dic1.Add CStr(temp1), 0
            If Not Dic2.exists(CStr(temp2)) Then Dic2.Add CStr(temp2), 0
        Else
            temp1 = X
            If Not Dic1.exists(CStr(temp1)) Then Dic1.Add CStr(temp1), 0
        End If
    Next

    Set objFile = objFSO.OpenTextFile(BreakFile, ForReading)
    strContents = objFile.ReadAll: objFile.Close: Set objFile = Nothing
     
    Set objFile = objFSO.OpenTextFile(BreakFile, ForWriting)

    arrlines = Split(strContents, vbCrLf)
    If Len(arrlines(UBound(arrlines))) = 0 Then
     end_ = UBound(arrlines) - 1
     Else
     end_ = UBound(arrlines)
     End If

     For i = 0 To end_
        X = arrlines(i)
        If InStr(X, ";") > 0 Then
            temp = Split(X, ";")(5)

            If Dic1.exists(CStr(temp)) Then
                If Dic2.exists(CStr(temp)) Then '   , ..  
                    objFile.Writeline X
                Else    '  
                    objFile.Writeline Split(X, ";")(0) & ";" & _
                                      Split(X, ";")(1) & ";" & _
                                      Split(X, ";")(2) & ";" & _
                                      Split(X, ";")(3) & ";" & _
                                      first1 & ";" & _
                                      Split(X, ";")(5)
                End If
            Else
                If Dic2.exists(CStr(temp)) Then  '  
                    objFile.Writeline Split(X, ";")(0) & ";" & _
                                      Split(X, ";")(1) & ";" & _
                                      Split(X, ";")(2) & ";" & _
                                      Split(X, ";")(3) & ";" & _
                                      first2 & ";" & _
                                      Split(X, ";")(5)
                Else
                    objFile.Writeline X    ' 
                End If
            End If
        Else
            objFile.Writeline X '   ";"
        End If
    Next
    
objFile.Close: Set objFile = Nothing

'End Sub
